"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var font_picker_service_1 = require('./font-picker.service');
var font_picker_component_1 = require('./font-picker.component');
var interfaces_1 = require('./interfaces');
var FontPickerDirective = (function () {
    function FontPickerDirective(resolver, el, vc, cd, service) {
        this.resolver = resolver;
        this.el = el;
        this.vc = vc;
        this.cd = cd;
        this.service = service;
        this.created = false;
        this.fpWidth = '280px';
        this.fpHeight = '320px';
        this.fpFallbackFont = new interfaces_1.Font({
            family: 'Roboto',
            styles: ['regular'],
            style: 'regular',
            size: 14
        });
        this.fpPosition = 'right';
        this.fpPositionOffset = '0%';
        this.fpPositionRelativeToArrow = false;
        this.fpCancelButton = false;
        this.fpCancelButtonText = 'Cancel';
        this.fpCancelButtonClass = 'fp-cancel-button-class';
        this.fpUploadButton = false;
        this.fpUploadButtonText = 'Upload';
        this.fpUploadButtonClass = 'fp-upload-button-class';
        this.fontPickerChange = new core_1.EventEmitter();
    }
    FontPickerDirective.prototype.ngOnInit = function () {
        var fontPicker = this.fontPicker;
        if (!this.fontPicker) {
            this.fontPicker = this.fpFallbackFont;
        }
        this.fontPickerChange.emit(this.fontPicker);
        if (fontPicker != this.fontPicker) {
            this.cd.detectChanges();
        }
    };
    FontPickerDirective.prototype.onClick = function () {
        if (!this.created) {
            this.created = true;
            var factory = this.resolver.resolveComponentFactory(font_picker_component_1.FontPickerComponent);
            var component = this.vc.createComponent(factory, 0);
            component.instance.setDialog(this, this.el, this.fontPicker, this.fpPosition, this.fpPositionOffset, this.fpPositionRelativeToArrow, this.fpPresetLabel, this.fpPresetFonts, this.fpUploadButton, this.fpUploadButtonClass, this.fpUploadButtonText, this.fpCancelButton, this.fpCancelButtonClass, this.fpCancelButtonText, this.fpHeight, this.fpWidth);
            this.dialog = component.instance;
        }
        else if (this.dialog) {
            this.dialog.updateDialog(this.fontPicker, this.fpPresetLabel, this.fpPresetFonts);
            this.dialog.openFontPicker();
        }
    };
    __decorate([
        core_1.Input('fontPicker'), 
        __metadata('design:type', interfaces_1.Font)
    ], FontPickerDirective.prototype, "fontPicker", void 0);
    __decorate([
        core_1.Input('fpWidth'), 
        __metadata('design:type', String)
    ], FontPickerDirective.prototype, "fpWidth", void 0);
    __decorate([
        core_1.Input('fpHeight'), 
        __metadata('design:type', String)
    ], FontPickerDirective.prototype, "fpHeight", void 0);
    __decorate([
        core_1.Input('fpFallbackFont'), 
        __metadata('design:type', interfaces_1.Font)
    ], FontPickerDirective.prototype, "fpFallbackFont", void 0);
    __decorate([
        core_1.Input('fpPresetLabel'), 
        __metadata('design:type', String)
    ], FontPickerDirective.prototype, "fpPresetLabel", void 0);
    __decorate([
        core_1.Input('fpPresetFonts'), 
        __metadata('design:type', Array)
    ], FontPickerDirective.prototype, "fpPresetFonts", void 0);
    __decorate([
        core_1.Input('fpPosition'), 
        __metadata('design:type', String)
    ], FontPickerDirective.prototype, "fpPosition", void 0);
    __decorate([
        core_1.Input('fpPositionOffset'), 
        __metadata('design:type', String)
    ], FontPickerDirective.prototype, "fpPositionOffset", void 0);
    __decorate([
        core_1.Input('fpPositionRelativeToArrow'), 
        __metadata('design:type', Boolean)
    ], FontPickerDirective.prototype, "fpPositionRelativeToArrow", void 0);
    __decorate([
        core_1.Input('fpCancelButton'), 
        __metadata('design:type', Boolean)
    ], FontPickerDirective.prototype, "fpCancelButton", void 0);
    __decorate([
        core_1.Input('fpCancelButtonText'), 
        __metadata('design:type', String)
    ], FontPickerDirective.prototype, "fpCancelButtonText", void 0);
    __decorate([
        core_1.Input('fpCancelButtonClass'), 
        __metadata('design:type', String)
    ], FontPickerDirective.prototype, "fpCancelButtonClass", void 0);
    __decorate([
        core_1.Input('fpUploadButton'), 
        __metadata('design:type', Boolean)
    ], FontPickerDirective.prototype, "fpUploadButton", void 0);
    __decorate([
        core_1.Input('fpUploadButtonText'), 
        __metadata('design:type', String)
    ], FontPickerDirective.prototype, "fpUploadButtonText", void 0);
    __decorate([
        core_1.Input('fpUploadButtonClass'), 
        __metadata('design:type', String)
    ], FontPickerDirective.prototype, "fpUploadButtonClass", void 0);
    __decorate([
        core_1.Output('fontPickerChange'), 
        __metadata('design:type', Object)
    ], FontPickerDirective.prototype, "fontPickerChange", void 0);
    FontPickerDirective = __decorate([
        core_1.Directive({
            selector: '[fontPicker]',
            host: {
                '(click)': 'onClick()'
            }
        }), 
        __metadata('design:paramtypes', [core_1.ComponentFactoryResolver, core_1.ElementRef, core_1.ViewContainerRef, core_1.ChangeDetectorRef, font_picker_service_1.FontPickerService])
    ], FontPickerDirective);
    return FontPickerDirective;
}());
exports.FontPickerDirective = FontPickerDirective;
//# sourceMappingURL=font-picker.directive.js.map